#include "finger.h"

Finger::Finger() : _servo_val(100)
{
  ser = Servo();
}
Finger::~Finger()
{
}

void Finger::init(int pin, int min_s, int max_s)
{
  ser.attach(pin);
  _servo_min = min_s; 
  _servo_max = max_s; 
  pin_s = pin;
  ser.write(_servo_max);
  _servo_val = _servo_max;
  //calc_line();
}


void Finger::close_finger()
{
  if(_servo_val >= _servo_min)
	  ser.write(_servo_val);
  return;
}


void Finger::open_finger()
{
	//go back to zero position
	if(!reached_max())
 {
  _servo_val+=10;
  ser.write(_servo_val); 
 }
 else
 {
  ser.write(_servo_val);
 }
   delay(5);
}

bool Finger::reached_max()
{
  if (_servo_val >= _servo_max)
    return true;
  return false;
}

void Finger::calc_line()
{
  int count = 0;
  for (int n = 0; n<3; n++)
  {
    for(int m = 0; m < 19; m++)
    {
      fb[m][n] = 0;
    }
  }
 
  for( int n(0); n <3;n++)
  {
    for(int d(_servo_max); d >=_servo_min;d-=10)
    {
       ser.write(d);
       delay(500);
       fb[d/10][n]= analogRead(pin_s);
    }
    count++;
  }

  for(int m = 0; m < 19; m++)
  {
    float u = (fb[m][0] + fb[m][1] + fb[m][2])/count;
    float sd = sqrt(((float(fb[m][0])-u)*(float(fb[m][0])-u) + (float(fb[m][1])-u)*(float(fb[m][1])-u) + (float(fb[m][2])-u)*(float(fb[m][2])-u))/count); 
    fb[m][3] = u;
    fb[m][4] = round(sd);
    Serial.print(fb[m][3]);
    Serial.print('\t');
    Serial.println(fb[m][4]);
  }
  ser.write(_servo_max);
  _servo_val = _servo_max;
  delay(500);
}


float Finger::get_position()
{
  //normalise
  float no = (float(_servo_val) - float(closed))/(float(_servo_max) - float(closed));
  Serial.println(no);
  return no;
}


bool Finger::resistance()
{
  if (state == 0)
    return true;
  int fb_m = analogRead(pin_s);
  delay(5);
  int fb_e = fb[_servo_val/10][3];
  Serial.print("Pin: \t"); 
  Serial.print(pin_s);
  Serial.print(" \t");
  Serial.print(_servo_val/10);
  Serial.print(" \t");
  Serial.print(fb_e);
  Serial.print(" \t");
  Serial.print(fb_m);
  Serial.print(" \t");
  int res = abs(fb_m - fb_e);
  Serial.print(res);
  Serial.print('\n');
  if ((res>=(2+fb[_servo_val/10][4]))|| (_servo_val <= _servo_min))
  {
   if(_servo_val <=100)
   {
      return true;
   }
  } 
  if (_servo_val > _servo_min)
  {
    _servo_val -=10;
    return false;
  }
  return true;
  
}
