#ifndef FINGER_H
#define FINGER_H

#include "Arduino.h"
#include "Servo.h"

//extern int global_ref;

class Finger
{
public:
	Finger();
  Servo ser;
	~Finger();

  void init(int pin, int min_s, int max_s);
	void close_finger();
	void open_finger();
  bool reached_max();
  bool resistance();
  void calc_line();
  float get_position();
  void set_closed_pos(){closed = _servo_val;}
  void detach_finger(){ser.detach();delay(100);}
  void attach_finger(){ser.attach(pin_s);delay(100);}
  void set_state(int s){state = s;};
  int get_state(){return _servo_val - _servo_min;};
  
private:  
	int fb [19][5];
	int _servo_val;
  int pin_s;
  int closed;
  int _servo_min;
  int _servo_max;
  float a;
  float b;
  int state;
};

#endif //FINGER_H

