#include "hand.h"

Hand::Hand(int f): _num_fingers(f)
{
	for (int n(0); n < _num_fingers; n++)
	{
		Finger* f = new Finger();
		fingers[n] = f;
	}
}



Hand::~Hand()
{
 delete [] fingers;
}



void Hand::init_hand(int pins[], int mins[], int maxs[])
{
  for (int n(0); n < _num_fingers; n++)
  {
    fingers[n]->init(pins[n], mins[n], maxs[n]);
    Serial.println("init_fingers called");
  }
  for (int n(0); n < _num_fingers; n++)
  {
    fingers[n]->calc_line();
  }
  execute_grasp();
 
  for (int m(0); m < _num_fingers; m++)
  {
    fingers[m]->set_closed_pos();
  }
  delay(500);
  release_grasp();
}

bool Hand::reached_max()
{
  int yes = 0;
  for(int n(0); n <_num_fingers; n++)
    {
      if (states[n] == 0)
        yes++;
      else
      {
        if(fingers[n]->reached_max())
        {
          yes++;
        }  
      }  
    }
    if(yes == _num_fingers)
    {
      return true;
    }
  return false;
}

void Hand::execute_grasp(int fins[])
{ 
//  Serial.println("in grasp");
//   //use all available fingers
//   for (int r = 0; r < _num_fingers; r++)
//   {
//    states[r] = fins[r];
//    Serial.println(states[r]);
//    //fingers[r]->set_state(states[r]);
//   }
    while(!reached_min())
    {
      
       for(int n(0); n <_num_fingers; n++)
      {
         fingers[n]->close_finger();
      }
      delay(5);
    }
      //delay(1000);
    Serial.println("Closed"); 
}

void Hand::release_grasp()
{
  Serial.print('\n');
  while(!reached_max())
  {
    for(int n(0); n <_num_fingers; n++)
    {
      fingers[n]->open_finger();
    }
  }
}


void Hand::get_positions()
{
  float buf [_num_fingers];
  for(int n(0); n <_num_fingers; n++)
    {
      buf[n] = fingers[n]->get_position(); 
    }
  Serial.print("pos: "); 
  for(int n(0);n<_num_fingers;n++)
  {
    Serial.print(buf[n]);
    Serial.print(", ");  
  }
  Serial.print('\n');
}



bool Hand::reached_min()
{
  int yes = 0;

  for (int m(0); m<_num_fingers;m++)
  {
    fingers[m]->detach_finger();
  }
  for(int n(0); n <_num_fingers; n++)
    {
      fingers[n]->attach_finger();
      if(fingers[n]->resistance())
      {
        yes++;
      }
      fingers[n]->detach_finger();
    } 
  for (int p(0); p<_num_fingers;p++)
  {
     fingers[p]->attach_finger(); 
  }
  if(yes == _num_fingers)
  {
    return true;
  }
  return false;
}

